   ;------------------------------------------------------------;
   ;  Nzev    : Potadlo jzd vtahu                   	;
   ;  Autor    : Pavel Jank                             	;
   ;  Vroba   : 2-3.2005					;
   ;  Verze    : 1.3 (14.3.2005)	 		 	;
   ;  Maximum  : 999 999 jzd Nahoru + 999 999 Dolu	 	;
   ;  Zobraz.  : po stisku tlatka na 3-mstnm displeji 	;
   ;------------------------------------------------------------;

DAT	BIT P1.0                ;seriove data na pos. reg.
CLK	BIT P1.1                ;hodiny pos. reg.
STR	BIT P1.2		;strobovani (H = data z pos. reg. na LCD)
OE	BIT P1.3		;povoli zapisovat data
NAHORU	BIT P1.4		;Nahoru   (vstup)
N_TLAC  BIT P1.5		;Nahoru - tlatko
DOLU	BIT P1.6		;Dolu     (vstup)
D_TLAC  BIT P1.7		;Dolu   - tlatko
;-------------------------------
;R0 	- 			 Pomocnej - ochr. proti zakmitum tlacitka
;R1 	- 			 Pomocnej - ochr. proti zakmitum tlacitka
;R2	- 			 casova prodleva
;R3	- 			 casova prodleva
;R4	- 			 casova prodleva
;R6 	- 			 Pomocnej - vyssi rady zobrazovani
;R7 	- 			 kolikrat byl bit vyslan na pos. reg. (8)
;-------------------------------
D1	EQU 10H			;D - jednotky
D2	EQU 11H			;D - desitky
D3	EQU 12H                 ;D - stovky
D4	EQU 13H                 ;D - tisice
D5	EQU 14H                 ;D - desetitisice
D6	EQU 15H                 ;D - statisice
D456	EQU 16H			;D - cifra je v radu tisice a vic
;-------------------------------
N1	EQU 18H                ;N - jednotky
N2	EQU 19H                ;N - desitky
N3	EQU 1AH
N4	EQU 1BH
N5	EQU 1CH
N6	EQU 1DH
N456	EQU 1EH
;==============================================================================
	ORG 000H
	JMP NASTAV			;Po resetu skoc na nastaveni programu

NASTAV: MOV P1,#11111101B		;vynuluj CLK
	MOV P3,#11111111B               
	MOV N1,#0			;vynuluje "pamet" cisel N
	MOV N2,#0
	MOV N3,#0
	MOV N4,#0
	MOV N5,#0
	MOV N6,#0
	MOV N456,#0
	MOV D1,#0
	MOV D2,#0
	MOV D3,#0
	MOV D4,#0
	MOV D5,#0
	MOV D6,#0				
	MOV D456,#0
	MOV R0,#255
	MOV R1,#255	
	CLR STR
;------------------------------------------------------------------------------
;postupne roluje na displeji PJV (Pocitadlo Jizd Vytahu)
	CLR  OE				;povoli zobrazovat na displeji
	MOV  A,#10101000B              	;P
	CALL VYSILEJ                    ;vysli pripravena data na displej
	MOV  A,#11111111B
	CALL VYSILEJ
	MOV  A,#11111111B
	CALL VYSILEJ
	SETB STR   			;prenes data z pos. reg. na displej
	CALL POCKEJ			;pauza pred rolovanim displeje
	CLR  STR
	MOV  A,#10010101B  		;J 
	CALL VYSILEJ
	MOV  A,#10101000B              	;P
	CALL VYSILEJ
	MOV  A,#01111111B
	CALL VYSILEJ
	SETB STR
	CALL POCKEJ
	CLR  STR
	MOV  A,#10010001B		;V 	
	CALL VYSILEJ
	MOV  A,#00010101B  		;J 
	CALL VYSILEJ
	MOV  A,#00101000B              	;P
	CALL VYSILEJ
	SETB STR
	CALL POCKEJ
	CALL POCKEJ
	CALL POCKEJ	
	CLR  STR
	SETB OE
;------------------------------------------------------------------------------
;testuje vstupy N, D, tlac N, tlac D
START:	DJNZ R0,START  			;ochrana proti zakmitum
	JNB  NAHORU,N_PLUS		;pri sepnuti stykace N pricti N+1
	JNB  DOLU,D_PLUS		;pri sepnuti stykace D pricti D+1
	JNB  N_TLAC,N_ZOB0  		;pri stisku tlac N zobraz na displeji
	JNB  D_TLAC,D_ZOB0	        ;pri stisku tlac D zobraz na displeji
	JMP  START
N_ZOB0: CALL N_ZOBRAZ			;vyvolej podprogram zobrazeni Nahoru
	JMP  START
D_ZOB0: CALL D_ZOBRAZ                   ;vyvolej podprogram zobrazeni Dolu
	JMP  START		
;------------------------------------------------------------------------------
N_PLUS:	DJNZ R0,$			;ochrana proti zakmitum
	DJNZ R1,$-2
	INC  N1				;pricti N1 +1 (jednotky)
	MOV  A,N1
	CJNE A,#10,N_KONEC              ;kdyz N1=10, tak N2+1 a N1 vynuluj
	MOV  N1,#0			;N1 vynuluj
	INC  N2                         ;N2 +1
	MOV  A,N2
	CJNE A,#10,N_KONEC              ;kdyz N2=10, tak N3+1 a N2 vynuluj
	MOV  N2,#0
	INC  N3
	MOV  A,N3
	CJNE A,#10,N_KONEC              ;kdyz N3=10, tak N4+1 a N3 vynuluj
	MOV  N456,#255			;nastav kdyz je cifra vetsi jak 999
	MOV  N3,#0
	INC  N4
	MOV  A,N4
	CJNE A,#10,N_KONEC              ;kdyz N4=10, tak N5+1 a N4 vynuluj
	MOV  N4,#0
	INC  N5
	MOV  A,N5
	CJNE A,#10,N_KONEC              ;kdyz N5=10, tak N6+1 a N5 vynuluj
	MOV  N5,#0
	INC  N6
	MOV  A,N6
	CJNE A,#10,N_KONEC              ;kdyz N6=10, TAK N1+1 a N6 vynuluj
	MOV  N6,#0
	INC  N1	

N_KONEC:JNB  N_TLAC,N_ZOB1  		;pri stisku tlac N zobraz na displeji
	JNB  D_TLAC,D_ZOB1	        ;pri stisku tlac D zobraz na displeji
	JMP  N_KON1			;nebylo stisknuto tlac N, D => preskoc
N_ZOB1:	CALL N_ZOBRAZ                   ;vyvolej podprogram zobrazeni Nahoru
	JMP  N_KON1    			;pri navratu z N_ZOBRAZ preskoc D_ZOBRAZ
D_ZOB1:	CALL D_ZOBRAZ 		        ;vyvolej podprogram zobrazeni Dolu
N_KON1:	JNB  NAHORU,N_KONEC		;cekej dokud se nepust (nevypne) tlac.	
	JMP  START			;vrat se k testovani
;------------------------------------------------------------------------------
D_PLUS:	DJNZ R0,$			;ochrana proti zakmitum
	DJNZ R1,$-2	
	INC  D1				;pricti D1 +1 (jednotky)
	MOV  A,D1
	CJNE A,#10,D_KONEC              ;kdyz D1=10, tak D2+1 a D1 vynuluj
	MOV  D1,#0			;D1 vynuluj
	INC  D2                         ;D2 +1
	MOV  A,D2
	CJNE A,#10,D_KONEC              ;kdyz D2=10, tak D3+1 a D2 vynuluj
	MOV  D2,#0
	INC  D3
	MOV  A,D3
	CJNE A,#10,D_KONEC              ;kdyz D3=10, tak D4+1 a D3 vynuluj
	MOV  D456,#255			;nastav kdyz je cifra vetsi jak 999
	MOV  D3,#0
	INC  D4
	MOV  A,D4
	CJNE A,#10,D_KONEC              ;kdyz D4=10, tak D5+1 a D4 vynuluj
	MOV  D4,#0
	INC  D5
	MOV  A,D5
	CJNE A,#10,D_KONEC              ;kdyz D5=10, tak D6+1 a D5 vynuluj
	MOV  D5,#0
	INC  D6
	MOV  A,D6
	CJNE A,#10,D_KONEC              ;kdyz D6=10, TAK D1+1 a D6 vynuluj
	MOV  D6,#0
	INC  D1	

D_KONEC:JNB  N_TLAC,N_ZOB2  		;pri stisku tlac N zobraz na displeji
	JNB  D_TLAC,D_ZOB2	        ;pri stisku tlac D zobraz na displeji
	JMP  D_KON1			;nebylo stisknuto tlac N, D => preskoc
N_ZOB2:	CALL N_ZOBRAZ                   ;vyvolej podprogram zobrazeni Nahoru
	JMP  D_KON1
D_ZOB2:	CALL D_ZOBRAZ 		
D_KON1:	JNB  DOLU,D_KONEC		;cekej dokud se nepust (nevypne) tlac.	
	JMP  START			;vrat se k testovani
;------------------------------------------------------------------------------
;upravi a vysila data na 3-mistnem displej (654 ..pauza.. 321 ..pauza)
N_ZOBRAZ:MOV DPTR,#TAB_ZNK		;uloz pocatecni adresu tabulky
	CLR  OE				;povoli zobrazovat na displeji
	
	MOV  R6,N456
	CJNE R6,#255,N_123		;zjisti jestli ma zobrazovat na 456 mist
 
	MOV  A,N4
	MOVC A,@A+DPTR	          	;najdi v TAB_CIS a prirad bin. hodnotu
	ANL  A,#01111111B               ;rozsvit DP na pravem displeji (pokrac)
	CALL VYSILEJ                    ;vysli pripravena data na displej
	MOV  A,N5
	MOVC A,@A+DPTR
	CALL VYSILEJ
	MOV  A,N6
	MOVC A,@A+DPTR
	ANL  A,#01111111B               ;Nahoru - rozsvit smerovku N
	CALL VYSILEJ
	SETB STR   			;prenes data z pos. reg. na displej
	
	CALL PAUZA			;pauza pred rolovanim displeje

N_123:	CLR  STR			;zablokuje prenos dat z pos. reg. LED
	MOV  A,N1
	MOVC A,@A+DPTR	          	;najdi v TAB_CIS a prirad bin. hodnotu
	CALL VYSILEJ                    ;vysli pripravena data na displej
	MOV  A,N2
	MOVC A,@A+DPTR
	CALL VYSILEJ
	MOV  A,N3
	MOVC A,@A+DPTR
	ANL  A,#01111111B               ;Nahoru - rozsvit smerovku N
	CALL VYSILEJ
	SETB STR   			;prenes data z pos. reg. na displej

	CALL PAUZA			;pauza pred rolovanim displeje
	CLR  STR
	SETB OE
	
	RET
;------------------------------------------------------------------------------
;upravi a vysila data na 3-mistnem displej (654 ..pauza.. 321 ..pauza)
D_ZOBRAZ:MOV DPTR,#TAB_ZNK		;uloz pocatecni adresu tabulky
	CLR  OE				;povoli zobrazovat na displeji
	
	MOV  R6,D456
	CJNE R6,#255,D_123		;zjisti jestli ma zobrazovat na 456 mist
	
	MOV  A,D4
	MOVC A,@A+DPTR	          	;najdi v TAB_CIS a prirad bin. hodnotu
	ANL  A,#01111111B               ;rozsvit DP na pravem displeji (pokrac)	
	CALL VYSILEJ                    ;vysli pripravena data na displej
	MOV  A,D5
	MOVC A,@A+DPTR
	ANL  A,#01111111B               ;Dolu - rozsvit smerovku D
	CALL VYSILEJ
	MOV  A,D6
	MOVC A,@A+DPTR
	CALL VYSILEJ
	SETB STR   			;prenes data z pos. reg. na displej
	
	CALL PAUZA			;pauza pred rolovanim displeje

D_123:	CLR  STR			;zablokuje prenos dat z pos. reg. LED
	MOV  A,D1
	MOVC A,@A+DPTR	          	;najdi v TAB_CIS a prirad bin. hodnotu
	CALL VYSILEJ                    ;vysli pripravena data na displej
	MOV  A,D2
	MOVC A,@A+DPTR
	ANL  A,#01111111B               ;Dolu - rozsvit smerovku D	
	CALL VYSILEJ
	MOV  A,D3
	MOVC A,@A+DPTR
	CALL VYSILEJ
	SETB STR   			;prenes data z pos. reg. na displej

	CALL PAUZA			;pauza pred rolovanim displeje
	CLR  STR
	SETB OE
	
	RET
;------------------------------------------------------------------------------
VYSILEJ:MOV  R7,#8     			;vysilani jednoho bitu 8x (8-bitu)
VYSLI:  RRC  A                    	;posun vpravo v ACC o jeden bit do C
	CLR  CLK                        ;vypni CLocK pos. reg.
	MOV  DAT,C			;vysli C na vstup DAT pos. reg.
	SETB CLK			;pri CLK=1 se zapisi DATa do pos. reg.
	DJNZ R7,VYSLI			;sniz R7,kdyz R7<>0 tak opakuj vysilani
	CLR  C
        RET
;------------------------------------------------------------------------------
;pauza pro zobrazeni na disleji asi 3s  (255*255*23*2cykly=3s)
PAUZA:	MOV  R2,#255
	MOV  R3,#255
	MOV  R4,#23
PAUZ1:	DJNZ R2,PAUZ1 			;dekrementuj R2 az do 0 (trva 2 cykly)
	DJNZ R3,PAUZ1			;kdyz R2 255...0 tak R3-1
	DJNZ R4,PAUZ1	                ;kdyz R3 255...0 tak R4-1
	RET                             
;------------------------------------------------------------------------------
;pauza mezi zobrazovanim uvodniho PJV 
POCKEJ:	MOV  R2,#255
	MOV  R3,#255
	MOV  R4,#5
PAUZ2:	DJNZ R2,PAUZ2
	DJNZ R3,PAUZ2
	DJNZ R4,PAUZ2
        RET
;------------------------------------------------------------------------------
;tabulka prirazeni kodu pro LED displej cislu 0 az 9
TAB_ZNK:DB 10000001B			;cislo 0
	DB 10011111B			;cislo 1
	DB 10100100B			;cislo 2
	DB 10000110B			;cislo 3
	DB 10011010B			;cislo 4
	DB 11000010B			;cislo 5
	DB 11000000B			;cislo 6
	DB 10001111B			;cislo 7
	DB 10000000B			;cislo 8
	DB 10000010B			;cislo 9
;==============================================================================
; Copyright (C) PaJa 2005   /   www.paja-trb.cz   /   paja@paja-trb.cz